10 ! *********************************************
20 ! *                                           *
30 ! *                BARRIKAD                   *
40 ! *                                           *
50 ! *   Programmerat av Mattias Eriksson 2017   *
60 ! *             Version 170107                *
70 ! *                                           *
80 ! *   Spelprogrammet {r {mnat f|r ABC 806     *
90 ! *********************************************
100 INTEGER : EXTEND
110 ! *** INITIERA: ***
120 P1=0 : P2=0 : Ram=0
130 FGCTL BLK+BLU+YEL+RED
140 Z=FNClr
144 ! *** RITA INTRO: ***
145 Ram=FNIntro
146 Z=FNClr
150 ! *** S{tt startvariabler: ***
160 X1=10 : Y1=220 : Dir1=1
170 X2=500 : Y2=10 : Dir2=0
180 ! *** RITA RAM: ***
190 IF Ram=1 THEN Z=FNRitaRam
200 ! *** HUVUDLOOP: ***
210 ! *** Inmatning S1 Ww,Aa,Ss,Dd samt S2 8,4,5,6: ***
220 Tryck=INP(34)
230 IF ((Tryck=87 OR Tryck=119) AND Dir1<>1) OR Dir1=0 THEN Dir1=0 : Y1=FNUpp(Y1)
250 IF ((Tryck=83 OR Tryck=115) AND Dir1<>0) OR Dir1=1 THEN Dir1=1 : Y1=FNNed(Y1)
280 IF ((Tryck=65 OR Tryck=97)  AND Dir1<>3) OR Dir1=2 THEN Dir1=2 : X1=FNV{n(X1)
300 IF ((Tryck=68 OR Tryck=100) AND Dir1<>2) OR Dir1=3 THEN Dir1=3 : X1=FNH|g(X1)
320 IF (Tryck=56 AND Dir2<>1) OR Dir2=0 THEN Dir2=0 : Y2=FNUpp(Y2)
340 IF (Tryck=53 AND Dir2<>0) OR Dir2=1 THEN Dir2=1 : Y2=FNNed(Y2)
360 IF (Tryck=52 AND Dir2<>3) OR Dir2=2 THEN Dir2=2 : X2=FNV{n(X2)
380 IF (Tryck=54 AND Dir2<>2) OR Dir2=3 THEN Dir2=3 : X2=FNH|g(X2)
390 ! *** Kontrollera om n}gon spelare kraschat: ***
400 IF FGPOINT(X1,Y1)<>0 THEN 500
410 IF FGPOINT(X2,Y2)<>0 THEN 600
420 ! *** Rita ut spelarna: ***
430 FGPOINT X1,Y1,1
440 FGPOINT X2,Y2,2
450 GOTO 220
460 ! *** SLUT HUVUDLOOP ***
490 ! *** RUNDA KLAR: ***
500 Z=FNClr
510 ; CUR(0,18) DBLE FLSH YEL "Spelare 2 vann!"
520 P2=P2+1
530 V=FNSpelaIgen
540 IF V=1 THEN 146 ELSE 6000
600 Z=FNClr
610 ; CUR(0,18) DBLE FLSH BLU "Spelare 1 vann!"
620 P1=P1+1
630 V=FNSpelaIgen
640 IF V=1 THEN 146 ELSE 6000
998  ! *********************************************
999  ! *** FUNKTIONER: ***
1000 ! *** Spelare upp: ***
1010 DEF FNUpp(Y)
1020   Y=Y+1
1030   IF Y>239 THEN Y=0
1040   RETURN Y
1050 FNEND
1100 ! *** Spelare ned: ***
1110 DEF FNNed(Y)
1120   Y=Y-1
1130   IF Y<0 THEN Y=239
1140   RETURN Y
1150 FNEND
1200 ! *** Spelare v{nster: ***
1210 DEF FNV{n(X)
1220   X=X-2
1230   IF X<0 THEN X=510
1240   RETURN X
1250 FNEND
1300 ! *** Spelare h|ger: ***
1310 DEF FNH|g(X)
1320   X=X+2
1330   IF X>511 THEN X=0
1340   RETURN X
1350 FNEND
1400 ! *** Clear screen ***
1410 DEF FNClr
1420   ; CHR$(12)
1430   FGPOINT 0,0,0
1440   FGFILL 511,239
1450   RETURN 0
1460 FNEND
1500 ! *** Rita ram ***
1510 DEF FNRitaRam
1520   FGPOINT 0,0,0
1530   FGLINE 511,0,3 : FGLINE 511,230,3
1540   FGLINE 0,230,3 : FGLINE 0,0,3
1550   RETURN 0
1560 FNEND
1590 ! *** Spela igen-prompt ***
1600 DEF FNSpelaIgen
1610   ; CUR(4,28) BLU "Vinster spelare 1: ";P1
1620   ; CUR(5,28) YEL "Vinster spelare 2: ";P2
1630   ; CUR(12,26) CYA "Vill ni spela igen (J/N)?"
1640   IF SYS(5)<>0 THEN GET S$
1650   IF S$="j" OR S$="J" THEN RETURN 1
1660   IF S$="n" OR S$="N" THEN RETURN 0
1670   GOTO 1640
1680 FNEND
5000 ! *** Rita intro ***
5010 DEF FNIntro
5020   ; CUR(2,28) DBLE GRN "-BARRIKAD-"
5030   ; CUR(10,0) GRN ULN "                          ***** Instruktioner: *****"
5040   ; CUR(11,7) CYA "Spelare ett och tv} styr varsin linje, m}let med spelet {r att f}"
5050   ; CUR(12,7) CYA "din motst}ndare att krascha i muren, sin egen eller din linje!"
5060   ; CUR(14,27) BLU "Spelare 1 styr med W,A,S,D."
5070   ; CUR(15,27) YEL "Spelare 2 styr med 8,4,5,6."
5080   ; CUR(17,26) CYA "PF1: Starta ett spel utan mur."
5090   ; CUR(18,26) CYA "PF2: Starta ett spel med mur."
5100   ; CUR(23,17) RED "Programmerat av Mattias Eriksson januari 2017."
5110   Tryck=INP(34)
5120   IF Tryck=192 THEN RETURN 0
5130   IF Tryck=193 THEN RETURN 1
5140   GOTO 5110
5150 FNEND
5980 ! ********************************************
5990 ! *** PROGRAMAVSLUT: ***
6000 Z=FNClr
6010 END